{- 
Time-stamp: <Wed Sep 29 2010 20:50:22 Stardate: Stardate: [-28]3758.92 hwloidl>
The program algins sequene  of gentiec (RNA). It uses D&C  and data
parallelism .  
The program  original  generated the RNA  sequence randomly, but for parallel test  we just  explicitly define three set  of inputs  yss short execution  run , xss for medium execution  run, and  xs for long execution run.  
-} 


module Main where  
import System(getArgs) 
--import GlaExts(trace) 
  
import List  
import Random
#if defined(STRATEGIES)
# if defined(EVAL_STRATEGIES)
import Control.Parallel.Strategies
import Control.DeepSeq
import Control.Applicative (Applicative, pure, (<*>))
# elif defined(SM_STRATEGIES)
import Control.Parallel
import Control.DeepSeq
import Control.Parallel.Strategies
# else 
import Control.Parallel
import Control.Parallel.Strategies
# endif
#endif

data Aminoacid = A | C | U | G | D |I  
  deriving (Read,Show,Eq,Ord)  
  
type Sequence1 = [Aminoacid]  
type Pin1 = [Aminoacid] 
type SubSequence1 = [Aminoacid]
 
#if defined(STRATEGIES)
instance NFData Aminoacid

# if defined(EVAL_STRATEGIES)
parMap s f a = map f a `using` parList s
# endif
#endif

type Sequence = [Int] 
type Pin = [Int] 
type SubSequence = [Int]
-- This is accept chunk of sequences to be alignment and produce an alignment 
-- by calling the two top level functions  " top_level_bestpin" and  "divide" 
align_chunk :: Int -> Int -> [Sequence] -> -- List of input sequences.   
                [Sequence]   -- Aligned sequences.  
align_chunk th  n  [] = [] 
align_chunk th  n  xs  = fun_align all_res   
     where   
      best = top_level_bestpin  n  xs  
      all_res = divide th  n  xs best  
 
-- This divide takes  a list  sequences and a best pin for a given list split 
-- it  using  a pin  into three chunks left , right ,and unpinned chunk to be  
-- aligned independently  by concurrent calling between align_chunk and divide 
-- functions       
divide :: Int -> Int -> [Sequence] -> -- List of input sequences  
            Pin -> -- Best pin  
	   [Sequence]   -- List of aligned sequences.  
 
divide th n [] [] = []   
divide th  n xs [] = xs -- this is represent the basic alignment to the sequence  
divide th  n xs ys = (combine pin_var res_lift' res_right' res_unpinch')
        where
        (res_lift', res_right', res_unpinch') = 
                (res_lift, res_right, res_unpinch)
#if defined(STRATEGIES)
                `using` strategy 
#endif
	pin_var = ys   
        (rightch,leftch,unpinch1) = splitting_sequences ys xs  
        unpinch = lead_function pin_var unpinch1  
        res_unpinch = align_chunk (th-1)   n unpinch  
        res_right = align_chunk (th-1)  n rightch
        res_lift = align_chunk (th-1)  n leftch
#if defined(STRATEGIES)
# if defined(EVAL_STRATEGIES)
        strategy triple@(a,b,c)
          | th <= 0   = return triple
          | otherwise = do
              x <- (rpar `dot` rdeepseq) a
              y <- (rpar `dot` rdeepseq) b
              z <- (rpar `dot` rdeepseq) c
              return (x,y,z)
# elif defined(SM_STRATEGIES)
        strategy triple@(a,b,c)
          | th <= 0   = return triple
          | otherwise = do
              a' <- rdeepseq a
              x  <- rpar a'
              b' <- rdeepseq b
              y  <- rpar b'
              c' <- rdeepseq c
              z  <- rpar c'
              return (x,y,z)
# else
	strategy r@(a,b,c) = if th <= 0 then  ()  
                    	      else rnf  a `par`
	            	           rnf  b `par`
		    	           rnf  c `pseq` ()

# endif
#endif

#if 0
# warning OLD version with demanding above
#if defined(STRATEGIES)
# if defined(EVAL_STRATEGIES)
	strategy r =if th <= 0 then r else (ins rnf) res_lift `par`
	          (ins rnf) res_right  `par`
		  (ins rnf) res_unpinch  `seq`   r 
# elif defined(SM_STRATEGIES)
	strategy =if th <= 0 then  r0 res_right  else rdeepseq {- rnf -}  res_lift `par`
	          rnf  res_right  `par`
		  rnf  res_unpinch    
# else
	strategy =if th <= 0 then  ()  else rnf  res_lift `par`
	          rnf  res_right  `par`
		  rnf  res_unpinch    
# endif
#endif
#endif
	 
combine :: Pin -> [Sequence] ->[Sequence] ->[Sequence] -> [Sequence]  
combine  pin left_seqs right_seqs unpinned_seqs   
         = ( zipWith ( cat_sequence pin) left_seqs right_seqs) ++ unpinned_seqs    
         where  
           cat_sequence :: Sequence -> Sequence -> Sequence -> Sequence  
	   cat_sequence pin ls rs = ls ++ pin ++ rs   
 
 
-- The top_level_bestpin function takes a list of sequences and produce best as output  
 
top_level_bestpin :: Int -> [Sequence] -> -- List of input sequences.  
                       Pin    -- Best pin as output.    
top_level_bestpin n []= []  
top_level_bestpin n xs =  best_pin   pins_dis       
  where
    all_substring  = nub(par_substring_sequences n xs xs)
    pins = map  fst(extract_max_pins  all_substring ) 
    extract_longest_pins = longest_pin  pins  
    pins_dis =  par_pin_average_distance extract_longest_pins xs         
 
   
--------------------------------------------------------------- 
-- ALL FUNCTIONS CALLING BY top_level_bestpin FUNCTION       -- 
---------------------------------------------------------------  
substring_sequences :: Int -> [ Sequence] ->  Sequence  -> -- The input sequences  
                          [(Sequence,Int )]      -- list of substring list  
substring_sequences n ys  [] = []
substring_sequences n  ys   x    =  nub res1
          where
	   res =   subseq x
	   rr  = cluster n res
	   res1=  par_form_pin   ys rr     
   
subseq :: Sequence    -> -- A single sequences from the input sequences  
          [SubSequence ]    -- all substring from the input sequences  
subseq (x:xs) = inits (x:xs)++  subseq xs  
subseq [] = []  

par_substring_sequences ::  Int ->  [Sequence ] ->[Sequence ] ->[(Pin,Int )]
par_substring_sequences n  xs ys = foldr (++) [] 
#if defined(STRATEGIES)
# if defined(EVAL_STRATEGIES)
                                   (parMap rdeepseq   (substring_sequences n ys) xs )
# elif defined(SM_STRATEGIES)
                                   (parMap rdeepseq   (substring_sequences n ys) xs )
# else
                                   (parMap rnf        (substring_sequences n ys) xs )
# endif
#else
                                   (map               (substring_sequences n ys) xs )
#endif

par_form_pin ::  [Sequence ]->[[SubSequence]]-> [(Pin,Int )] 
par_form_pin xs ys = foldr (++) [] ( map  ( form_pins xs ) ys) 
 
cluster :: Int ->  [SubSequence]   -> [[SubSequence]]  
cluster  n [] = []
cluster  n xs = take n xs : cluster n (drop n xs)

form_pins :: [Sequence ] ->    -- Alist of all substring of a single sequence.
              [SubSequence]  ->   -- A list of input sequences  
	    [(Pin,Int )]    -- List of pins and it is occurrence.

form_pins [] [] =  [] 
form_pins ys []  = []     
form_pins  ys   (x:xs)
   | num > 1 =  (x,num) : form_pins  ys xs  
   | otherwise =    form_pins  ys xs   
   where 
   num = form_pins' x ys

form_pins' :: SubSequence    ->  -- Single element from substring list 
              [Sequence]  ->  -- A list of input sequences  
	       Int            -- Number of occurrence as pins  
form_pins' [] [] = 0
form_pins' m []  = 0 
form_pins' m (x:xs) 
  |((check_for_snd_appears == Nothing ) &&(check_for_appears /= Nothing )) =    1+ form_pins' m xs 
  |otherwise =  form_pins' m xs 
  where
   check_for_appears   = locate_pin m x
   where_pin_appears = pin_value(check_for_appears)
   reset_of_sequence  = drop (where_pin_appears + length m ) x
   check_for_snd_appears =  locate_pin  m reset_of_sequence   
 
extract_max_pins  ::     [(Pin,Int )] -> [ (Pin ,Int )]     
extract_max_pins [] =[]  
extract_max_pins ((p,n):xss) = foldr  (extract_max_pins')  [(p,n)]  xss   
 
      	    
extract_max_pins' :: (Pin ,Int)  ->[ (Pin,Int)] ->  [(Pin,Int)] 
--extract_max_pins'   []   []  = [] 
-- extract_max_pins'  aa_pin  []   = aa_pin    
extract_max_pins'  (p,n) aa_pin@((p',n'):_)   
     | n' >  n  =   aa_pin     
     | n' ==  n  = aa_pin ++ [(p,n)]    
     | otherwise = [(p,n)]                

parfoldList  :: 
#if defined(STRATEGIES)
                NFData a  => 
#endif
                (a -> [a]-> [a]) -> [a] -> [a] ->[a]
parfoldList  f z [] = z 
parfoldList  f z (x:xs) = 
#if defined(STRATEGIES)
# if defined(EVAL_STRATEGIES)
                          runEval $ pure f <*> r0 x <*> (rpar `dot` rdeepseq) ys -- Applicative functor style parallelism
# elif defined(SM_STRATEGIES)
                          f  x ys `using` \ r -> rdeepseq ys `par` rwhnf r -- `sparking` rdeepseq ys	
# else
                          f  x ys `using` \ r -> rnf ys `par` rwhnf r
# endif
#else
                          f  x ys
#endif
     where 
     ys = parfoldList  f z xs 

remove_prefix_pins'' [] yss = yss  
remove_prefix_pins'' (xs:xss) yss = remove_prefix_pins'' xss (remove_prefix_pins' yss xs)  
  
remove_prefix_pins' ::  [Pin] -> -- A list of all maximum occurrence pins  
              Pin  -> -- single pins  
	      [Pin]   -- List of pins after deleting Prefix pins        
remove_prefix_pins'   xss xs = deleteBy (\ x y -> y/=x && ( isPrefixOf y x  ) ) xs xss   
  
remove_suffix_pins ::  [Pin] -> -- A list of all maximum occurrence pins after removing perfixs elements.  
           [Pin]   -- List of pins after deleting suffixes pins  
remove_suffix_pins xss = foldl remove_suffix_pins' xss xss  
remove_suffix_pins' :: [Pin] -> -- A list of all maximum occurrence pins after removing perfixs elements.  
                        Pin  -> -- single pins  
	               [Pin]  -- List of pins after deleting suffixes pins of given pin  
-- Th  is function is to delete suffix element from selected pins   
remove_suffix_pins' xss ys 
   |  res == xss =  res 
   | otherwise  =  remove_suffix_pins' res ys   
  where  
  res = deleteBy (\ x y -> y/=x && ( isSuffixOf y x ) ) ys xss   
 
longest_pin  ::	 [Pin] ->[Pin]   
longest_pin [] = [] 
longest_pin (xs:xss) = foldr  (longest_pin') [xs] xss  
 
longest_pin' ::  Pin  ->[Pin] ->[Pin] 
longest_pin' pin  xs@(pin':_) 
     | length pin' >  length pin   = xs  
     | length pin' ==  length pin  = (pin:xs)  
     |  otherwise = [pin]          
    
par_pin_average_distance ::  [Pin]-> [Sequence] -> [(Pin, Int )]
par_pin_average_distance  [] [] = []  
par_pin_average_distance [] _ = []  
par_pin_average_distance _ [] = []
par_pin_average_distance  xs ys = map  (pin_average_distance  n ys) xs
  where 
   n = length ys

pin_average_distance ::   Int->[Pin]  ->   -- A list of pins   
                          Pin   ->   -- A list of input sequences  
			    (Pin, Int )  -- A list of pins with its average distance from the middle   
-- THIS FUNCTION IS TO FIND THE PIN AVERAGE DISTANCE FROM MIDDLE OF THE SEQUENCES  
   
pin_average_distance  n xs ys = (ys ,((sum (map ( pin_average_distance' ys) xs ) `div` n  )))     
    where  
    pin_average_distance'  :: Pin   -> Sequence ->   Int   
    pin_average_distance' [] [] = 0  
    pin_average_distance' xs ys  
      |  check_res == Nothing   = 0  
      | otherwise = abs(((length ys) `div` 2) -  
       ((pin_value ( check_res )) + (length xs  `div` 2)))  
        where 
	 check_res = locate_pin xs ys
 

 
best_pin ::  [(Pin,Int)] -> -- A list of pins with its average distance from the middle.  
         Sequence     -- A best pin base on the nearest value to the middle.  
-- This function is produce the pin which contain the minimum distance  
    
best_pin [] = [] 
  
best_pin ((p,n):xs) = fst( best_pin' (p,n)  xs)    
best_pin' (p,n) [] = (p,n)  
best_pin' (p',n') ((p,n):xs)  
  |  n <= n'   =   best_pin' (p,n) xs  
  | otherwise = best_pin' (p',n') xs  
    
 
--------------------------------------------------------------- 
-- ALL FUNCTIONS CALLING BY divide  FUNCTION                 -- 
---------------------------------------------------------------  
 
splitting_sequences :: Pin  -> -- Best pin   
                    [Sequence] -> -- List of input Sequences   
		   ([Sequence] , [Sequence] , [Sequence]) -- The output contain three parts left , right ,and unpinned  
splitting_sequences [] [] = ([], [] ,[])  
splitting_sequences [] ys = (ys, [], [])  
splitting_sequences xs ys  = (right_chunk , lift_chunk , unpinned)  
       where  
        right_chunk = right_sequence xs ys  
        lift_chunk = left_sequence xs ys  
        unpinned = unpinned_chunk xs ys   
        
 
right_sequence :: Pin  -> -- best pin.  
                 [Sequence] -> -- List of input sequences.  
	         [Sequence]   -- List of right sequences.   
  
right_sequence [] [] = []  
right_sequence [] ys = ys         
right_sequence xs ys = map (right_sequence' xs ) (pined_chunk xs ys)   
    where  
    right_sequence' :: Pin ->  Sequence -> Sequence      
    right_sequence' [] [] = []  
    right_sequence' [] ys = ys  
    right_sequence' xs ys  
       | (num_pin + length xs)  == length ys  = []  
       | check_res /= Nothing = drop (  num_pin + (length  xs ))  ys  
       where
       check_res =  locate_pin xs ys
       num_pin  = pin_value( check_res) 
left_sequence :: Pin  -> -- best pin.  
                [Sequence] -> -- List of input sequences.  
	        [Sequence]   -- List of left sequences.   
left_sequence [] [] = []  
left_sequence [] ys = ys  
left_sequence xs ys = map (left_sequence' xs ) (pined_chunk xs ys)  
    where  
     left_sequence' :: Pin ->  Sequence -> Sequence    
     -- This function is extract the left sequence from single sequence  
     -- the inputs are best pin + single sequence.   
     left_sequence' [] [] = []  
     left_sequence' [] ys = ys	  
     left_sequence' xs ys  
        | num_pin  > 0 = take ( num_pin ) ys  
        | otherwise = [] 
	where 
	 num_pin =   pin_value (locate_pin xs ys) 
{-
unpinned_chunk :: Pin       -> -- best pin  
                [Sequence] -> -- List of input sequences .  
		[Sequence]   -- List of unpinned sequences  
unpinned_chunk [] [] = []  
unpinned_chunk [] ys = ys  
unpinned_chunk _ [] = []  
unpinned_chunk xs (ys:yss) 
       | eqNothing r1 =  ys : unpinned_chunk xs yss  
       | otherwise =  unpinned_chunk xs yss   
       where  
	 r1 =locate_pin xs ys -} 
unpinned_chunk    xs ys = filter(\y -> (locate_pin xs y) == Nothing)(ys)
pined_chunk   xs ys = filter(\y -> (locate_pin xs y) /= Nothing )(ys)
{-
pined_chunk :: Pin  -> -- best pin.  
             [Sequence] -> -- List of input sequences.  
	     [Sequence] -- List of pined sequences.  
pined_chunk [] [] = []  
pined_chunk [] _ = []  
pined_chunk _ [] = []  
pined_chunk xs (ys:yss)  
 | r1 /= Nothing  = ys :  pined_chunk xs yss  
 | otherwise   = pined_chunk xs yss   
  where  
   r1 =locate_pin xs ys -} 

locate_pin :: Pin       ->  -- Single pin.  
              Sequence  ->  -- Input sequence.  
              Maybe Int     -- position of the in the sequence. 
locate_pin  xs ys = locate_pin' xs ys 0 
locate_pin' xs [] n = Nothing  
locate_pin' xs (y:ys) n 
   | isPrefixOf xs (y:ys) = Just n 
   | otherwise  = locate_pin' xs ys (n+1)

pin_value :: Maybe Int -> Int		   
pin_value (Just x) = x  
pin_value Nothing = 0  
 
 
fun_align ::  [Sequence ] -> -- List of input sequences to aligned  
              [Sequence ]  -- List of sequences after insertion of delete character.    
fun_align [] = []  
fun_align xs = [ add_d x | x <- xs]  
  	    where  
	       m =  maximum [length x | x <- xs ]   
	       add_d ::  Sequence  -> Sequence   
	       add_d x  
	         | length x == m = x  
	 	 | otherwise = x ++ concat (replicate (m - length x) p)  
		   where  
		     p1 = concat (replicate (m - length x) p)   
		     p = [ 8 ]   
 
lead_function :: Sequence -> [Sequence]  -> [Sequence]   
lead_function [] [] = []   
lead_function  xs []  = []  
lead_function  [] ys  = ys  
lead_function   xs  ys =  map (lead_function' xs [] ) ys   
  
lead_function' [] align [] = align  
lead_function' xs align [] =align  
lead_function' [] align ys =(reverse align) ++ ys  
lead_function' (x:xs) align (y:ys)  
   | x ==y = res  
   | otherwise = res1  
   where  
   res = lead_function' xs (x:align) ys  
   res1 =lead_function' xs (9:align) (y:ys)  
  
 
  
test_align_length :: [Sequence]  -> Bool 
test_align_length [] = True 
test_align_length xs    
            | all(\x->(length x) == length (head xs)) xs = True 
	    | otherwise =False  
          
   
 -------------------------------------------------------------- 
--  FUNCTION TO GENERATE RANDOM  SET OF SEQUENCES           -- 
---------------------------------------------------------------  
mkRandom :: Int -> -- Input value represents the number of sequences  
            Int -> -- Input value represents the length of each sequences  
	    IO [[Aminoacid]] -- List of random input sequences  
  
mkRandom m n = do  
         let  
          g = mkStdGen 1701 -- deterministic input via fixed seed val  
          cs :: [Int]  
          cs = randoms g  
          cs0 = map (dd . (`mod` 4)) $ cs  
             
          dd 0 = A  
          dd 1 = C  
          dd 2 = G  
          dd 3 = U  
       
          mk_grid' 0 _ _ res = res  
          mk_grid' m n l res = mk_grid' (m-1) n l2 (l1:res)  
                    where (l1, l2) = splitAt n l  
  
          grid = mk_grid' m n cs0 []  
         return grid  


mkRandom1 :: Int -> -- Input value represents the number of sequences  
            Int -> -- Input value represents the length of each sequences  
	    IO [[Int]] -- List of random input sequences  
  
mkRandom1 m n = do  
         let  
          g = mkStdGen 1701 -- deterministic input via fixed seed val  
          cs :: [Int]  
          cs = randoms g  
          cs0 = map  (`mod` 4) $ cs  
           
       
          mk_grid' 0 _ _ res = res  
          mk_grid' m n l res = mk_grid' (m-1) n l2 (l1:res)  
                    where (l1, l2) = splitAt n l  
  
          grid = mk_grid' m n cs0 []  
         return grid 

seq1 0 _ = []  
seq1 n b = b:seq1 (n-1) b; 

next1 0 = 1  
next1 1 = 2  
next1 2 = 3  
next1 3 = 0  

gen 0 _ _ _ = []  
gen n i j b = 
     if i>j 
     then gen n 1 j b 
     else seq1 n b : gen (n-1) (i+1) j (next1 b)

 
 
tak 0 _ = []  
tak _ [] = []  
tak n (h:t) = h:tak (n-1) t; 

drop9 0 l = l  
drop9 _ [] = []  
drop9 n (_:t) = drop (n-1) t; 

split1 n [] = []  
split1 n l = tak n l:split1 n (drop9 n l); 

make1 m n l = split1 m (concat(gen (m*n) 1 l 0)); 


main = 	do args <- getArgs 
           let 
	     n = read (args!!0)  -- length of each input sequence 
	     l = read (args!!1)  -- length of each input sequence  
             p = read (args!!2)  -- chunk size
	     pe = read (args!!3)  -- chunk siz
           xs <-   mkRandom1 p pe 
#if defined(STRATEGIES)
	   putStrLn ("Strategies version "++strategies_version)
#endif
           print(show (  align_chunk n l xs))

