# Time-stamp: <Fri Feb 16 2001 17:15:54 Stardate: [-30]6198.59 hwloidl>
# 
# Boot makefile
#
# This makefile extracts the target and the way out of the target provided by 
# the user. It then calls make again assigning the components to variables.
# For example a call like
#  make foo_mg
# is translated into the following recursive call to make
#  make target=foo way=mg haskell=98 foo_mg
#
# Targets ending in an _ (underscore) are assumed to be Haskell 1.4
# Targets ending in an - (minus) are assumed to be Haskell 1.2
# Otherwise Haskell98 is assumed. 
#
# This file, as well as Makefile.common, must be included in the main
# makefile.
#
# ---------------------------------------------------------------------------

ifeq "$(target)" ""
%:
	@X="$@"; \
        FOO=$$X; \
        SUF="`echo $$FOO | sed -e 's/^\(.*\)\(.\)$$/\2/'`"; \
	case $$SUF in \
         _) echo echo "Haskell 1.4";  \
                 VERSION="1.4" ; \
	         BASE="`echo $$FOO | sed -e 's/^\(.*\)\(.\)$$/\1/'`"; \
	         ;; \
         -) echo "Haskell 1.2";  \
                 VERSION="1.2" ; \
	         BASE="`echo $$FOO | sed -e 's/^\(.*\)\(.\)$$/\1/'`"; \
	         ;; \
         o) echo "Haskell98 (building an object file only)";  \
                 VERSION="98" ; \
	         BASE=$$FOO; \
	         ;;  \
         *) echo "Haskell98";  \
                 VERSION="98" ; \
	         BASE=$$FOO; \
	         ;;  \
	esac; \
	PRG="`echo $$BASE | sed -e 's/^\(.*\)_\(.*\)/\1/'`"; \
	WAY="`echo $$BASE | sed -e 's/^\(.*\)_\(.*\)/\2/'`"; \
	if [ "$$PRG" = "$$BASE" ] ; \
	  then  WAY="" ;   \
	        PRG=$$BASE; \
	fi ; \
        echo "$(MAKE) target=$$PRG way=$$WAY haskell=$$VERSION $$BASE" ; \
        $(MAKE) --no-print-directory target=$$PRG way=$$WAY haskell=$$VERSION $$BASE
endif

#         echo "X=$$X; FOO=$$FOO; WAY=$$WAY; TARGET=$$TARGET"; \

