# Time-stamp: <Thu May 27 2010 19:08:18 Stardate: Stardate: [-28]3133.77 hwloidl>
#
# Generic definitions for all Makefiles underneath.
# To make do eg
#  make strategies=eval way=thr GHC=/u1/staff/hwloidl/OPT/bin/ghc-6.12.1.20100330 
# Supported strategies: 1 (or old), 2 (or sm), 3 (or eval)
# ----------------------------------------------------------------------------

GHC = ghc

ifeq "$(way)" ""
_WAY = 
else
_WAY = _$(way)
endif

# prg specific
GHC_FLAGS        = -cpp 
ifeq "$(way)" ""
WAY_FLAGS        = 
else
WAY_FLAGS        = -hisuf "$(way)_hi" -osuf "$(way)_o"
endif

# way specific
FLAGS_p      = -prof -auto-all
FLAGS_thr    = -threaded
FLAGS_thr_l  = -threaded -eventlog
FLAGS_pp     = -parpvm
FLAGS_debug_pp = -parpvm -debug

RTS_FLAGS_thr = +RTS -N4 -RTS
RTS_FLAGS_thr_l = +RTS -N4 -ls -sstderr -RTS

# # Input args (all ways)
# INPUTS_parMainFFT    = 1048576
# INPUTS_parMainFFT    = 1048576

# non app sources needed
# EXTRA_SRCS = Parallel.hs EvalStrategies.hs

ifeq "$(strategies)" ""
GHC_FLAGS += -i../../systemtest/par-modules/0
endif

ifeq "$(strategies)" "eval"  # Patrick Maier's revision of the strategies
	# EXTRA_SRCS +=  Parallel.hs EvalStrategies.hs # use this if the files are local
	# EXTRA += -package parallel # use this if the above files are not local but in a library
        # pickup EvalStrategies from this repo
	# EXTRA += -i../../systemtest/evalstratstests
	# DEFINES += -DSTRATEGIES -DEVAL_STRATEGIES
	GHC_FLAGS += -DSTRATEGIES -DEVAL_STRATEGIES -i../../systemtest/par-modules/0 -i../../systemtest/evalstratstests
else ifeq "$(strategies)" "3"  # same as eval
	# EXTRA_SRCS +=  Parallel.hs EvalStrategies.hs # use this if the files are local
	# EXTRA += -package parallel # use this if the above files are not local but in a library
	# pickup EvalStrategies from this repo
	# EXTRA += -i../../systemtest/evalstratstests
	# DEFINES += -DSTRATEGIES -DEVAL_STRATEGIES
	GHC_FLAGS += -DSTRATEGIES -DEVAL_STRATEGIES -i../../systemtest/par-modules/0 -i../../systemtest/evalstratstests
else # Simon Marlow's revision of the strategies
     ifeq "$(strategies)" "sm"
	# EXTRA_SRCS +=  
	# EXTRA += -package parallel
	# DEFINES += -DSTRATEGIES -DSM_STRATEGIES
	GHC_FLAGS += -DSTRATEGIES -DSM_STRATEGIES -i../../systemtest/par-modules/2
        # -package parallel
else ifeq "$(strategies)" "2"  # same as sm
	# EXTRA_SRCS +=  
	# EXTRA += -package parallel
	# DEFINES += -DSTRATEGIES -DSM_STRATEGIES
	GHC_FLAGS += -DSTRATEGIES -DSM_STRATEGIES  -i../../systemtest/par-modules/2
        # -package parallel
else  # Phil Trinder's original version of the strategies module
      ifeq "$(strategies)" "old"
	# EXTRA_SRCS += Parallel.hs Strategies.hs 
	# EXTRA += -i../../systemtest/modules # /Control/Parallel # pickup Strategies from this repo
	# DEFINES += -DSTRATEGIES -i../../systemtest/modules
	GHC_FLAGS += -DSTRATEGIES -i../../systemtest/modules
      endif
      ifeq "$(strategies)" "1"
	# EXTRA_SRCS += Parallel.hs Strategies.hs
	#EXTRA += -i../../systemtest/modules # /Control/Parallel # pickup Strategies from this repo
	# DEFINES += -DSTRATEGIES
	GHC_FLAGS += -DSTRATEGIES -i../../systemtest/modules
      endif
endif
# otw no strategies module
endif

ALL_FLAGS = $(GHC_FLAGS) $(DEFINES) $(EXTRA)

